/* Created by Anjuta version 1.1.97 */
/*	This file will not be overwritten */

#include <iostream>

#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <unistd.h>

#include <ctime>

using namespace std;

#include "CGameControl.h"
#include "CAI.h"
#include "CAIEasy.h"
#include "CAIHuman.h"
#include "CAIAB.h"

int main()
{
	
	// nastavime random
	srand(time(NULL));

	cout << "Awary - terminalova verze pro lepsi ladeni inteligence a zakladu -\n";
	
	CGameControl gc;
//	CAIAB    pl1(&gc, 2);
	CAIAB  pl1(&gc,  4);
	CAIAB  pl2(&gc,  8);
	
	gc.NewGame(7, 4, &pl1, &pl2);
//	gc.LoadHistory("save.hist");
	
	while ( gc.GameEnded() == GAME_ENDED_NO ) {

		// udelame tah
		gc.TimerTick();
		gc.NextTurn();

		// preklesleni
		if ( gc.StatusChanged() ) {
			st_game_status st = gc.GetStatus();
			printf("\nTah : %d\n", gc.GetTurnsCnt());
			int i;
			// 1. hrac
			cout << 1 << ": ";
			for ( i = 0; i <= st.cells; i++ ) { // policka
				cout << st.field[0][i] << "  ";
			}
			cout << "\n";
			
			// 2. hrac
			cout << 2 << ":    ";
			for ( i = st.cells; i >= 0; i-- ) { // policka
				cout << st.field[1][i] << "  ";
			}
			cout << "\n";
			
		}
		
		// otestujeme, zda nejaka inteligence nechce vstup z klavesnice
		int field;
		if ( pl1.WantUserInput() ) {
			cout << "Tah 1. hrace:\n";
			cin >> field;
			pl1.UserInput(field);
		}
		if ( pl2.WantUserInput() ) {
			cout << "Tah 2. hrace:\n";
			cin >> field;
			pl2.UserInput(field);
		}
		
		// malinka pauza
		sleep(1);
		cout << ".\n";
	}
	
	cout << "\nCasy hracu :\n";
	printf("1. hrac : %.0fs %d figurek\n", gc.GetTime(0), gc.GetStatus().field[0][0]);
	printf("2. hrac : %.0fs %d figurek\n", gc.GetTime(1), gc.GetStatus().field[1][0]);
	printf("Pocet tahu hry : %d\n", gc.GetTurnsCnt());
	printf("Konecny vysledek : %d\n", gc.GameEnded());
	
	gc.SaveHistory("save.hist");
	
	return (0);
}
