//
// File: CAIEasy.h
// Created by: berny <2berny@seznam.cz>
// Created on: Thu Aug  7 08:07:22 2003
//

#include <stdlib.h>
#include <assert.h>
#include "CAIEasy.h"
#include "Global.h"

CAIEasy::CAIEasy(CGameControl *gc)
:CAI(gc)
{

}


CAIEasy::~CAIEasy()
{
	
}

// vrati cellik, kam si inteligence mysli, ze by se melo hrat
// nepracuje s internim stavem, aby bylo mozne volat zvenku
int CAIEasy::GetCell(const st_game_status  *status)
{
	assert( status != NULL );
	
	int max = -100000, mv = 1;       // maximum rozdilu, cislo policka pro tah
	int pl = status->player, op;  // nas hrac, oponent
	if ( pl == 0 ) op = 1;
	else op = 0;
	
	// vyzkousime vsechny tahy a vybereme ten s nejlepsim rozdilem
	// poctu kamenu v domecku
	for ( int i = 1; i <= status->cells; i++ ) {
		st_game_status st = *status;
		if ( gsMakeMove(&st, i) ) { // zkusime provest tah a zhodnotime, jak dopad
			int score = st.field[pl][0] - st.field[op][0];
			if ( score > max || (score == max && rand()%2 == 0) ) { // otestujeme a pridame trochu nahodnosti
				max = score;
				mv = i;
			}
		}
	}
	
	return mv;
}
