//
// File: Global.h
// Created by: berny <2berny@seznam.cz>
// Created on: Mon Aug  4 09:35:17 2003
//

#ifndef _GLOBAL_H_
#define _GLOBAL_H_

/*
	struktura pro urceni aktualniho stavu hry
*/
#define MAX_CELLS 20 // vic uz by snad ani nemelo smysl 
typedef struct {
	int player;                // kdo zrovna je na tahu ( 0 ,  1)
	int field[2][MAX_CELLS+1]; // 0 - vzdy domecek - slo by dynamicky, ale nevyplatilo by se to
	int cells;                 // pocet platnych hracich poli 
} st_game_status;

// nekolik "utilizacnich" funkci pracujici se stavem hry
bool gsCanMove(const st_game_status *status,  int cellID); // zda muze aktualni hrac hrac s urcitym polickem
bool gsMakeMove(st_game_status *status, int cellID);       // provede tah aktualnim hracem a zmeni hrace na druheho. Vraci false, pokud byl pokus o nedovoleny tah. Nekontroluje gsCanMove()
bool gsMakeMoveCheck(st_game_status *status, int cellID);  // provede tah aktualnim hracem a pripadne zmeni hrace na druheho. Vraci false, pokud byl pokuso nedovoleny tah.
bool gsCanMove(st_game_status *status);                    // zda muze aktualni hrac vubec hrat (ma nejaky mozny tah)
bool gsCanMoveConst(const st_game_status *status);         // zda muze aktualni hrac vubec hrat (ma nejaky mozny tah)
bool gsGameEnded(const st_game_status *status);            // vraci true, pokud hra zkoncila - kameny jsou jen v domecku

#endif
